#include <kglobal.h>
#include <klocale.h>
#include <kconfig.h>
#include <kapplication.h>
#include <kmessagebox.h>
#include <kaboutapplication.h>

#include "bioritmiapplet.h"
#include "qbioritmi.h"

BioritmiApplet::BioritmiApplet(const QString& configFile, Type type, int actions, QWidget *parent, const char *name)
    : KPanelApplet(configFile, type, actions, parent, name)
{
	ksConfig = config();

	KAboutData aboutdata("bioritmiapplet", I18N_NOOP("Biorithms Applet"), "0.1",
					I18N_NOOP("A Kicker applet that shows biorithms"), KAboutData::License_GPL,
					"(C) 2003 Flameeyes", 0, "http://flameeyes.web.ctonet.it",
					"dgp85@users.sourceforge.net");

	aboutdata.addAuthor( "Flameeyes", "Primary author", "dgp85@users.sourceforge.net", "http://flameeyes.web.ctonet.it" );
	aboutbox = new KAboutApplication(&aboutdata, this, "aboutbox" );

	mainView = biolabel = new QBioritmi(ksConfig, this, "bioritmilabel");
	biolabel->setGeometry( QRect(0, 0, width(), height()) );
	mainView->show();
}

BioritmiApplet::~BioritmiApplet()
{
	delete biolabel;
	delete aboutbox;
}

void BioritmiApplet::paint()
{
	ksConfig->setGroup("dates");
	biolabel->paintBioritmi(ksConfig->readDateTimeEntry("birthdate").date(), QDate::currentDate());
}

void BioritmiApplet::about()
{
    aboutbox->show();
}

void BioritmiApplet::preferences()
{
	appletconfig *configDialog = new appletconfig(this);
	if ( configDialog->exec() )
		paint();
	delete configDialog;
}

int BioritmiApplet::widthForHeight(int height) const
{
    return height*3;
}

int BioritmiApplet::heightForWidth(int width) const
{
    return width/3;
}

void BioritmiApplet::resizeEvent(QResizeEvent *e)
{
	biolabel->setGeometry( QRect(0, 0, width(), height()) );
	paint();
}


extern "C"
{
    KPanelApplet* init( QWidget *parent, const QString configFile)
    {
        KGlobal::locale()->insertCatalogue("bioritmiapplet");
        return new BioritmiApplet(configFile, KPanelApplet::Normal,
                             KPanelApplet::About | KPanelApplet::Preferences,
                             parent, "bioritmiapplet");
    }
}
